﻿Imports System
Imports System.Collections.Generic
Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks
Imports System.Windows
Imports System.Windows.Data


Namespace DataTreeVB

Public Class ViewModel

	Public Menus As ObservableCollection(Of entMenuItem)
	Public SelectedMenuItems() As Object

	Private NoLevels As Integer = 1

	Public Sub New()
		CreateData()
	End Sub

	Private names() As String = {"Current Menu", "New Menu", "Old Menu", "Buffet Menu", "Holiday Menu", "Buffet2 Menu", "Elegant Manu", "Family Menu",
									 "Small Affair Menu", "Local Menu"}

Private Sub CreateData()
	Dim r As New Random()
	Menus = New ObservableCollection(Of entMenuItem)()
	For i As Integer = 0 To 9
		Dim gd As New entMenuItem()
		With gd
			.ID = i
			.Description = names(r.[Next](10))
			.IsSelected = False
			.Children = New ObservableCollection(Of entMenuItem)()
		End With
		AddChildren(gd, 1)
		Menus.Add(gd)
	Next

	'Menus[0].IsSelected = true;
	Menus(0).Children(1).IsSelected = True

	Menus(1).Children(0).IsSelected = True

	Menus(1).Children(2).IsSelected = True

	For Each menu As entMenuItem In Menus
		Dim childCnt As Integer = menu.Children.Count()
		Dim selCnt As Integer = (From m In menu.Children Where m.IsSelected Select m).Count()

		If selCnt > 0 Then
			If selCnt = childCnt Then
				menu.IsSelected = True
			Else
				menu.IsSelected = Nothing
			End If

		End If
	Next

	For Each menu As entMenuItem In Menus(3).Children
		menu.IsSelected = True
	Next
	Menus(3).IsSelected = True

End Sub


Private Sub AddChildren(gd As entMenuItem, levelNo As Integer)
	Dim r As New Random()
	Dim NoChildren As Integer = r.[Next](3, 15)
	Dim levelStr As String = "1"
	For i As Integer = 0 To levelNo - 1
		levelStr += "0"
	Next

	Dim levelMult As Integer = Integer.Parse(levelStr)
	For i As Integer = 0 To NoChildren - 1
		Dim gd2 As New entMenuItem()
		With gd
			.ID = levelMult + i
			.Description = names(r.[Next](10))
			.IsSelected = False
			.Children = New ObservableCollection(Of entMenuItem)()
		End With

		If levelNo < NoLevels Then
			AddChildren(gd2, levelNo + 1)
		End If

		gd.Children.Add(gd2)
	Next
End Sub

End Class

Public Class entMenuItem
	Implements INotifyPropertyChanged

	Public Event PropertyChanged(sender As Object, e As PropertyChangedEventArgs) Implements INotifyPropertyChanged.PropertyChanged

	Private _id As Integer
	Private _name As String
	Private _isSelected As Nullable(Of Boolean)
	Public Children As ObservableCollection(Of entMenuItem)

	Public Property ID As Integer
		Get
			Return _id
		End Get
		Set(value As Integer)
			_id = value
			OnPropertyChanged("ID")
		End Set
	End Property

	Public Property Description As String
		Get
			Return _name
		End Get
		Set(value As String)
			_name = value
			OnPropertyChanged("Description")
		End Set
	End Property

	Public Property IsSelected As Nullable(Of Boolean)
		Get
			Return _isSelected
		End Get
		Set(value As Nullable(Of Boolean))
			_isSelected = value
			OnPropertyChanged("IsSelected")
		End Set
	End Property

	Protected Overridable Sub OnPropertyChanged(propertyName As String)
		RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyName))
	End Sub

End Class

Public Class VisConverter
	Implements IValueConverter

		Public Function Convert(value As Object, targetType As Type, parameter As Object, culture As Globalization.CultureInfo) As Object Implements IValueConverter.Convert
			If (TypeOf (value) Is Boolean AndAlso DirectCast(value, Boolean).Equals(True) AndAlso parameter.ToString.Equals("true")) Then
				Return Visibility.Visible
			End If
			If (TypeOf (value) Is Boolean AndAlso DirectCast(value, Boolean).Equals(False) AndAlso parameter.ToString.ToLower.Equals("false")) Then
				Return Visibility.Visible
			End If
			Return Visibility.Collapsed
		End Function

		Public Function ConvertBack(value As Object, targetType As Type, parameter As Object, culture As Globalization.CultureInfo) As Object Implements IValueConverter.ConvertBack
			Throw New NotImplementedException
		End Function
End Class

End Namespace

